﻿using GanttPrototype.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GanttPrototype.Data
{
    public class DataGenerator
    {
        public static void Generate(out List<Batch> batches, out List<DownTime> downTimes)
        {
            batches = new List<Batch>();
            downTimes = new List<DownTime>();

            // USED TIMES

            DateTime h13m30 = DateTime.Today.AddMinutes(810);
            DateTime h14m00 = DateTime.Today.AddMinutes(840);
            DateTime h14m50 = DateTime.Today.AddMinutes(890);
            DateTime h15m00 = DateTime.Today.AddMinutes(900);

            // MACHINES

            Machine fruitCutter1 = new Machine { Name = "Fruit cutter #1" };
            Machine fruitCutter2 = new Machine { Name = "Fruit cutter #2" };
            Machine doughCutter = new Machine { Name = "Dough cutter" };
            Machine pieMaker = new Machine { Name = "Pie maker" };
            Machine oven = new Machine { Name = "Oven" };

            // ARTICLES

            Article apple = new Article { Name = "apple" };
            Article pear = new Article { Name = "pear" };
            Article banana = new Article { Name = "banana" };
            Article dough = new Article { Name = "dough" };
            Article applePie = new Article { Name = "apple pie" };
            Article fruitPie = new Article { Name = "fruit pie" };

            // DOWNTIMES

            //downTimes.Add(new DownTime
            //{
            //    StartTime = DateTime.Today.AddMinutes(0),
            //    Duration = TimeSpan.FromMinutes(10),
            //    Target = pieMaker,
            //    Reason = "Clean",
            //    Feedback = "Clean up after making fruit pies"
            //});

            downTimes.Add(new DownTime
            {
                StartTime = h15m00,
                Duration = TimeSpan.FromMinutes(60),
                Target = pieMaker,
                Reason = "Maintenance",
                Feedback = "The conveyor belt needs to be oiled"
            });

            downTimes.Add(new DownTime
            {
                StartTime = h15m00,
                Duration = TimeSpan.FromMinutes(30),
                Target = doughCutter,
                Reason = "Inspection",
                Feedback = "Check the sharpness of the blades"
            });

            // BATCHES

            batches.Add(new Batch
            {
                StartTime = h13m30,
                Duration = TimeSpan.FromMinutes(20),
                Executor = fruitCutter2,
                Amount=1500,
                Article = apple,
                Info = "cut apples"
            });

            batches.Add(new Batch
            {
                StartTime = h13m30,
                Duration = TimeSpan.FromMinutes(25),
                Executor = doughCutter,
                Amount = 500,
                Article = dough,
                Info = "cut dough"
            });

            batches.Add(new Batch
            {
                StartTime = h14m00,
                Duration = TimeSpan.FromMinutes(45),
                Executor = pieMaker,
                Amount = 500,
                Article = applePie,
                Info = "create pies"
            });

            batches.Add(new Batch
            {
                StartTime = h14m50,
                Duration = TimeSpan.FromMinutes(80),
                Executor = oven,
                Amount = 500,
                Article = applePie,
                Info = "bake pies"
            });
        }
    }
}
